.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

extrn	lstrlen			: PROC
extrn	lstrcpyn		: PROC
extrn	_wsprintfA		: PROC
extrn	gethostbyname		: PROC
extrn	socket			: PROC
extrn	closesocket		: PROC
extrn	connect			: PROC
extrn	send			: PROC
extrn	WSAAsyncSelect		: PROC
extrn	HeapAlloc		: PROC
extrn	HeapFree		: PROC

extrn	MainWnd			: DWORD
extrn	Memory_Heap		: DWORD
extrn	saddr			: SOCKADDR

.Data
	PacketBuffer		DD		0
	Http_Data		DD		0
	CurHttpData		DD		?
	CurHttpID		DD		?
PUBLIC	PacketBuffer
PUBLIC	Http_Data

	HTTP_HEADER		DB		"GET %s HTTP/1.1", 0Ah
		DB	"Pragma: no-cache", 0Ah
		DB	"Cache-Control: no-cache", 0Ah
		DB	"Range: bytes=0-", 0Ah
		DB	"Accept: */*", 0Ah
		DB	"Accept-Language: zh-tw", 0Ah
		DB	"Accept-Encoding: gzip, deflate", 0Ah
		DB	"User-Agent: Mozilla/4.0 (compatible; MSIE 4.0; Windows 95)", 0Ah
		DB	"Host: %s", 0Ah
		DB	"Connection: Keep-Alive", 0Ah, 0Ah, "!"

.Code

PUBLIC	HttpGetFile

; prepare the packet for http request

Packet_HTTP	PROC, server:DWORD, url:DWORD
	mov	esi, url
	cld
@@pkhttp_0:
	lodsb
	cmp	al, '/'
	jne	@@pkhttp_0
	dec	esi
	call	_wsprintfA, PacketBuffer, OFFSET HTTP_HEADER, esi, server
	ret
Packet_HTTP	ENDP

; get a file from internet by http

HttpGetFile	PROC, url:DWORD, saveas:DWORD, exeflag:DWORD
	cmp	Http_Data, 0
	jne	@@HttpBypassAlloc

	call	HeapAlloc, Memory_Heap, HEAP_GENERATE_EXCEPTIONS, HTTP_BUF_SIZE + MAX_HTTP*HTTP_STRUC_
	or	eax, eax
	jz	@@Http_FAIL
	mov	PacketBuffer, eax
	add	eax, HTTP_BUF_SIZE
	mov	Http_Data, eax

	mov	edi, eax
	xor	ebx, ebx
	mov	ecx, MAX_HTTP
@@InitHttpData:
	mov	[edi+ebx].http_sock, -1
	add	ebx, HTTP_STRUC_
	dec	ecx
	jnz	@@InitHttpData

@@HttpBypassAlloc:

	mov	edi, Http_Data
	xor	ebx, ebx
	xor	ecx, ecx
@@FindFreeHttp:
	cmp	[edi+ebx].http_sock, -1
	je	@@FoundFreeHttp
	add	ebx, HTTP_STRUC_
	inc	ecx
	cmp	ecx, MAX_HTTP
	jb	@@FindFreeHttp
	jmp	@@Http_FAIL

@@FoundFreeHttp:
	add	edi, ebx
	mov	CurHttpID, ecx
	mov	CurHttpData, edi

	mov	esi, url
				; edi -> CurHttpData->http_server
	cld
@@Http_0:
	lodsb
	or	al, al
	jz	@@Http_FAIL
	cmp	al, '/'
	je	@@Http_1
	stosb
	jmp	@@Http_0

@@Http_1:
	xor	al, al
	stosb

	mov	edi, CurHttpData
	call	gethostbyname, edi
	or	eax, eax
	jz	@@Http_FAIL

	mov	esi, [eax].h_addr
	mov	esi, [esi]
	mov	eax, [esi]

	mov	DWORD PTR saddr.sa_data[2], eax
	mov	BYTE PTR saddr.sa_data[0], 0
	mov	BYTE PTR saddr.sa_data[1], 80
	mov	saddr.sa_family, AF_INET

	call	socket, AF_INET, SOCK_STREAM, IPPROTO_TCP
	mov	[edi].http_sock, eax

	call	connect, eax, OFFSET saddr, SOCKADDR_
	cmp	eax, SOCKET_ERROR
	jne	@@Http_2

@@Http_FAIL_closesocket:
	call	closesocket, [edi].http_sock
	mov	[edi].http_sock, -1
	jmp	@@Http_FAIL

@@Http_FAIL_FREEBUF:
	call	HeapFree, Memory_Heap, 0, [edi].http_buffer
	jmp	@@Http_FAIL_closesocket

@@Http_2:
	call	Packet_HTTP, edi, url

	call	lstrlen, PacketBuffer
	inc	eax
	call	send, [edi].http_sock, PacketBuffer, eax, 0

	mov	[edi].http_bufsize, 16384
	call	HeapAlloc, Memory_Heap, HEAP_GENERATE_EXCEPTIONS, 16384
	or	eax, eax
	jz	@@Http_FAIL_closesocket

	mov	[edi].http_buffer, eax
	mov	[edi].http_data, 0
	mov	[edi].http_readlen, 0
	mov	[edi].http_cursize, 0
	mov	[edi].http_datasize, -1
	mov	eax, exeflag
	mov	[edi].http_exe, eax

	mov	eax, MSG_HTTP
	add	eax, CurHttpID
	call	WSAAsyncSelect, [edi].http_sock, MainWnd, eax, FD_READ+FD_CLOSE
	cmp	eax, SOCKET_ERROR
	je	@@Http_FAIL_FREEBUF

	mov	BYTE PTR [edi], 0
	call	lstrcpyn, edi, saveas, 255
	mov	eax, CurHttpID
	ret

@@Http_FAIL:
	mov	eax, -1
	ret
HttpGetFile	ENDP

END